package com.persagy.proxy.adm.constant;

import java.util.Map;

/**
 * ADM 通用常量
 * @author Charlie Yu
 * @date 2021-08-16
 */
public interface AdmCommonConstant {
	/** ADM 边类型 -> 枚举类 */
	static Map<String, AdmRelationTypeEnum> RELATION_TYPE_MAP = AdmRelationTypeEnum.getRelationTypeMap();
	
	/** 项目根路径*/
	String SERVER_ROOT_PATH = System.getProperty("user.dir");
	
	String EMPTY = "";
	
    /** appId */
    String APP_ID = "ADM";
    
    /** 默认的userId */
    String USER_ID = "systemId";

    /** 默认项目id */
    String PROJECTID = "system";

    /** 集团编码 header key*/
    String GROUP_CODE_HEADER = "groupCode";

    /** 项目ID header key*/
    String PROJECT_ID_HEADER = "projectId";
    
    /** appID header key*/
    String APP_ID_HEADER = "appId";
    
    /** userID header key*/
    String USER_ID_HEADER = "userId";
    
    /** excel文件后缀*/
    String EXCEL_SUFFIX_XLSX = ".xlsx";
    
    /** 连接符 ？ */
    String WHERE = "?";

    /** 连接符 & */
    String AND = "&";
    
    /** 连接符 _ */
    String UNDERLINE = "_";
    
    /** 连接符 - */
    String LINE_THROUGH = "-";
    
    /** 连接符 → */
    String RIGHT_ARROW = "→";
    
    /** 有效标示*/
    String VALID = "valid";

    /** 楼层标高 */
    String FLOOR_ELEVATION = "floorElevation";

}
