package com.persagy.proxy.adm.controller;

import cn.hutool.core.collection.CollUtil;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.basic.model.QueryCriteria;
import com.persagy.dmp.common.helper.SpringHelper;
import com.persagy.dmp.digital.entity.ObjectRelation;
import com.persagy.proxy.adm.constant.AdmCommonConstant;
import com.persagy.proxy.adm.model.AdmFloor;
import com.persagy.proxy.adm.model.AdmGraphicType;
import com.persagy.proxy.adm.model.AdmRelationType;
import com.persagy.proxy.adm.model.AdmWindow;
import com.persagy.proxy.adm.request.AdmCreateRequest;
import com.persagy.proxy.adm.request.AdmQueryCriteria;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.adm.service.IAdmGraphicTypeService;
import com.persagy.proxy.adm.service.IAdmRelationService;
import com.persagy.proxy.adm.service.IAdmRelationTypeService;
import com.persagy.proxy.adm.service.IAdmWindowService;
import com.persagy.proxy.adm.utils.AdmContextUtil;
import com.persagy.proxy.common.entity.InstanceUrlParam;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.ws.rs.QueryParam;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * ADM 窗户 API
 * @author xujiaheng
 * @date 2021-09-3
 */
@RestController
@RequestMapping("/rel")
public class AdmRelationController {

    @Autowired
    private IAdmGraphicTypeService service;

    @Value("${middleware.group.code}")
    private String groupCode;

    /**
     * 创建
     * @param
     * @return
     * @throws Exception
     */
    @PostMapping("/equip/category")
    public AdmResponse equipRel(@QueryParam("projectId") String projectId) {
        //组装上下文条件
        InstanceUrlParam context = AdmContextUtil.toDmpContext();
        AdmResponse res = service.query(context);
        return res;
    }
}
