package com.persagy.proxy.adm.controller;

import com.persagy.proxy.adm.constant.AdmCommonConstant;
import com.persagy.proxy.adm.model.AdmDtRelation;
import com.persagy.proxy.adm.model.AdmGraphicType;
import com.persagy.proxy.adm.request.AdmQueryCriteria;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.adm.service.IAdmDtRelationService;
import com.persagy.proxy.adm.service.IAdmGraphicTypeService;
import com.persagy.proxy.adm.utils.AdmContextUtil;
import com.persagy.proxy.common.entity.InstanceUrlParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.ws.rs.QueryParam;

/**
 * ADM 窗户 API
 * @author xujiaheng
 * @date 2021-09-3
 */
@RestController
@RequestMapping("/rel/obj")
public class AdmRelationObjectController {

    @Autowired
    private IAdmDtRelationService service;

    @Value("${middleware.group.code}")
    private String groupCode;

    /**
     * 创建
     * @param
     * @return
     * @throws Exception
     */
    @PostMapping("/equip/query")
    public AdmResponse equipRel(@QueryParam("projectId") String projectId) {
        //组装上下文条件
        InstanceUrlParam context = AdmContextUtil.toDmpContext();
        AdmQueryCriteria criteria = new AdmQueryCriteria();
        criteria.setFilters("projectId = "+context.getProjectId());
        AdmResponse admResponse = service.doQuery(context, criteria, AdmDtRelation.class);
        return admResponse;
    }
}
