package com.persagy.proxy.adm.model;

import lombok.Data;

import java.util.ArrayList;

/**
 * @ClassName AdmLocationPoint
 * @Description: ADM点位坐标实体类
 * @Author linhuili
 * @Date 2021/8/31 09:44
 * @Version V1.0
 **/
@Data
public class AdmLocationPoint {

    /** 点位标签ID */
    private String id;

    /** 名称 */
    private String name;

    /** 本地编码 */
    private String localId;

    /** 本地名称 */
    private String localName;

    /** 项目ID */
    private String projectId;

    /** 建筑ID */
    private String buildId;

    /** 楼层ID */
    private String floorId;

    /** 空间id */
    private String spaceId;

    /** BimId编码 */
    private String bimId;

    /** beaconID */
    private String beaconId;

    /** 位置 */
    private String position;

    /** 信息类型 */
    private String type;

    /** X坐标 */
    private String x;

    /** Y坐标 */
    private String y;

    /** 备注 */
    private String note;

    /** 图片信息 */
    private ArrayList<AdmPointImage> imageList;

    /** 类型编码，默认：LocationPoint */
    private String classCode="LocationPoint";

    /** 对象类型，默认：point */
    private String objType="point";
}
