package com.persagy.proxy.adm.model;

import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName AdmObjectType
 * @Description: ADM对象类型查询
 * @Author linhuili
 * @Date 2021/8/31 20:34
 * @Version V1.0
 **/
@Data
public class AdmObjectType {

    /** 全局id */
    private String id;

    /** 编码 */
    private String code;

    /** 名称 */
    private String name;

    /** 别编码 */
    private String aliasCode;

    /** 别编名 */
    private String aliasName;

    /** 分类:common平台级, group集团级, project项目级 */
    private String type;

    /** 集团id, 默认为 '0' */
    private String groupCode;

    /** 项目id, 默认为 '0' */
    private String projectId;

    /** 上级类型编码 */
    private String parentCode;

    /** 专业编码 */
    private String majorCode;

    /** 系统编码 */
    private String systemCode;

    /** 部件所属的设备类型 */
    private String equipmentCode;

    /** 对象类型 */
    private String objType;

    /** 子列表 */
    private List<AdmObjectType> children;

    /** 创建时间 */
    private String createTime;

    /** 更新时间 */
    private String lastUpdate;
}
