package com.persagy.proxy.adm.model;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;

import lombok.Getter;
import lombok.Setter;

/**
 * graphic/export 导出所使用的实体类对象
 * 
 * @version 1.0.0
 * @company persagy
 * @author zhangqiankun
 * @date 2021年9月3日 上午11:23:39
 */
@Getter
@Setter
public class AdmRelationObject {
	// 主对象
	// *识别编码 -- 对象ID
	@ExcelProperty(value = "*识别编码", index = 0)
	private String masterCode;
	// 设计图纸中编码
	@ExcelProperty(value = "设计图纸中编码", index = 1)
	private String masterCadId;
	// 对象名称
	@ExcelProperty(value = "对象名称", index = 2)
	private String masterName;
	// 对象id
	@ExcelProperty(value = "对象id", index = 3)
	private String masterId;
	// 对象本地编码
	@ExcelProperty(value = "对象本地编码", index = 4)
	private String masterLocalId;
	// 对象本地名称
	@ExcelProperty(value = "对象本地名称", index = 5)
	private String masterLocalName;
	// 对象-类型
	@ExcelProperty(value = "对象-类型", index = 6)
	private String masterType;
	// 所属建筑楼层 中划线隔开
	@ExcelProperty(value = "所属建筑楼层", index = 7)
	private String masterBelong;

	// 从对象
	// *识别编码 -- 对象ID
	@ExcelProperty(value = "*识别编码", index = 8)
	private String slaveCode;
	// 设计图纸中编码
	@ExcelProperty(value = "设计图纸中编码", index = 9)
	private String slaveCadId;
	// 对象名称
	@ExcelProperty(value = "对象名称", index = 10)
	private String slaveName;
	// 对象id
	@ExcelProperty(value = "对象id", index = 11)
	private String slaveId;
	// 对象本地编码
	@ExcelProperty(value = "对象本地编码", index = 12)
	private String slaveLocalId;
	// 对象本地名称
	@ExcelProperty(value = "对象本地名称", index = 13)
	private String slaveLocalName;
	// 对象-类型
	@ExcelProperty(value = "对象-类型", index = 14)
	private String slaveType;
	// 所属建筑楼层 中划线隔开
	@ExcelProperty(value = "所属建筑楼层", index = 15)
	private String slaveBelong;
	
	// 失败原因
	@ExcelProperty(index = 16)
	private String failureMsg;			// 失败原因
	
	@ExcelIgnore
	private String masterBuildingName;	// 建筑本地名称

	@ExcelIgnore
	private String masterFloorName;		// 楼层本地名称
	
	@ExcelIgnore
	private String slaveBuildingName;	// 建筑本地名称
	
	@ExcelIgnore
	private String slaveFloorName;		// 楼层本地名称
	
}
