package com.persagy.proxy.adm.request;

import lombok.Data;

import java.util.List;

/**
 * ADM通用查询条件
 * @author Charlie Yu
 * @date 2021-08-16
 */
@Data
public class AdmQueryCriteria {

    /** 可取得的最大记录数 */
    private Integer maxRow = 1000;
    /** 第几页(从1开始) */
    private Integer pageNumber;
    /** 每页记录数(0 < 记录数 < 1000) */
    private Integer pageSize;
    /** 查询条件 */
    private String filters;
    /** 排序条件 */
    private String orders;
    /** 去除重复记录 */
    private Boolean distinct;
    /** 级联对象属性名 - 为级联对象时有值 */
    private String name;
    /** 字段影射，空为查询所有字段 */
    private List<String> projection;
    /** 级联对象列表 */
    private List<AdmQueryCriteria> cascade;
    /** 分组统计 */
    private AdmQueryGroup group;
    /** 是否只统计总数 */
    private boolean onlyCount = false;
}
