package com.persagy.proxy.adm.service;

import com.persagy.proxy.adm.model.AdmManualRelCalRequest;
import com.persagy.proxy.adm.model.AdmManualRelationCalcDel;
import com.persagy.proxy.adm.model.AdmRelationAddRequest;
import com.persagy.proxy.adm.request.AdmCreateResponse;
import com.persagy.proxy.adm.request.AdmManualRelCalResponse;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.common.entity.InstanceUrlParam;

/***
 * Description: 手动关系计算逻辑处理接口
 * @author : lijie
 * @date :2021/8/31 12:14
 * Update By lijie 2021/8/31 12:14
 */
public interface AdmManualRelCalService {
    /***
     * Description: 添加关系
     *
     * @param context: 存储集团编码及项目id的上下文
     * @param request : 请求参数
     * @return : com.persagy.proxy.adm.request.AdmCreateResponse
     * @author : lijie
     * @date :2021/8/31 12:14
     * Update By lijie 2021/8/31 12:14
     */
    AdmCreateResponse addRels(InstanceUrlParam context, AdmRelationAddRequest request);
    /***
     * Description: 删除关系
     * @param admManualRelationCalcDel : 请求参数
     * @return : com.persagy.proxy.adm.request.AdmCreateResponse
     * @author : lijie
     * @date :2021/8/31 12:10
     * Update By lijie 2021/8/31 12:10
     */
    AdmCreateResponse delRels(InstanceUrlParam context, AdmManualRelationCalcDel admManualRelationCalcDel);
    /***
     * Description: 查询关系数据
     * @param admManualRelCalRequest : 请求参数
     * @return : com.persagy.proxy.adm.request.AdmCreateResponse
     * @author : lijie
     * @date :2021/8/31 12:10
     * Update By lijie 2021/8/31 12:10
     */
    AdmResponse query(InstanceUrlParam context, AdmManualRelCalRequest admManualRelCalRequest);

}
