package com.persagy.proxy.adm.service;

import com.persagy.proxy.adm.model.AdmDict;
import com.persagy.proxy.adm.model.AdmDictQueryCriteria;
import com.persagy.proxy.adm.model.AdmLocationPoint;
import com.persagy.proxy.adm.model.AdmObjectInfo;
import com.persagy.proxy.adm.request.AdmCreateRequest;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.common.entity.InstanceUrlParam;

import java.util.List;

/**
 * @ClassName IAdmDictService
 * @Description: 字典查询
 * @Author linhuili
 * @Date 2021/8/31 14:30
 * @Version V1.0
 **/
public interface IAdmDictService<T> extends IAdmDictBaseService<T>{

    /**
     * 查询字典分类
     * @param context
     * @param request
     * @param clazz
     * @return
     * @throws Exception
     */
    AdmResponse queryCategory(InstanceUrlParam context , AdmDict request, Class<T> clazz) throws Exception;


    /**
     * 重置项目下的定制信息点
     * @param context
     * @param clazz
     * @return
     * @throws Exception
     */
    AdmResponse resetDic(InstanceUrlParam context , AdmDictQueryCriteria request ,String fieldName, Class<T> clazz) throws Exception;

    /**
     * 设置-项目定制化字典
     * @param context
     * @param request
     * @return
     * @throws Exception
     */
    AdmResponse settingDicProject(InstanceUrlParam context , AdmCreateRequest<AdmObjectInfo> request, Class<T> clazz) throws Exception;


    /**
     * 查询所有字典信息 M 和 L 类型,包括自定义信息点
     * @param context
     * @param dictTypeList
     * @return
     */
    AdmResponse queryMorlDict(InstanceUrlParam context,List<String> dictTypeList);
}
