package com.persagy.proxy.adm.service;

import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.common.entity.InstanceUrlParam;

import java.util.List;

/**
 * @ClassName IAdmLabslService
 * @Description: 蜡笔森林定制接口
 * @Author linhuili
 * @Date 2021/9/17 20:01
 * @Version V1.0
 **/
public interface IAdmLabslService<T> extends IAdmDictBaseService<T> {

    /**
     * 查询项目下的设备类型
     * @return
     * @throws Exception
     */
    AdmResponse queryCategory(InstanceUrlParam context , Class<T> clazz) throws Exception;

    /**
     * 查询项目下的空间类型
     * @return
     * @throws Exception
     */
    AdmResponse queryZoneType(InstanceUrlParam context , Class<T> clazz) throws Exception;

    /**
     * 查询项目下的建筑楼层
     * @return
     * @throws Exception
     */
    AdmResponse queryBuildFloor(InstanceUrlParam context , Class<T> clazz) throws Exception;

    /**
     * 根据设备id统计设备所属的专业
     * @param context
     * @param ids
     * @param clazz
     * @return
     * @throws Exception
     */
    AdmResponse queryMajorCategory(InstanceUrlParam context ,List<String> ids , Class<T> clazz) throws Exception;
}
