package com.persagy.proxy.adm.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.proxy.adm.model.AdmDCSQueryRequest;
import com.persagy.proxy.adm.model.AdmSpace;
import com.persagy.proxy.adm.model.AdmUpDataFloorAndBuildingRequests;
import com.persagy.proxy.adm.request.AdmQueryCriteria;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.common.entity.InstanceUrlParam;

import java.util.List;

/**
 * ADM 空间 接口
 * @author lvxy
 * @date 2021/8/18
 */
public interface IAdmSpaceService extends IAdmBaseService<AdmSpace>{

    /**
     * 新增
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<AdmSpace> doInsertExt(InstanceUrlParam context, Class<AdmSpace> clazz, List<AdmSpace> voList);

    /**
     * 查询业务空间所有类型
     */
    AdmResponse doQueryType(InstanceUrlParam context, AdmDCSQueryRequest request);
    /**
     * 查询业务空间 级联查询：建筑（buildingList），楼层（floorlList），空间类型（objectType）未明确楼层(isnull),未明确建筑(isnull)
     */
    AdmResponse doQuerySpaces(InstanceUrlParam context, AdmDCSQueryRequest request);
    List<JSONObject> doQuerySpaceTypes(InstanceUrlParam context);
}
